'use strict';

/* globals Drupal,document */
(function (Drupal, document) {

  function onClick(event) {
    event.preventDefault();
    const unlockButton = event.target;
    const confirmationMessage = unlockButton.getAttribute('title') + "\n\n" + Drupal.t('Are you sure you want to proceed?');
    const confirmation = confirm(confirmationMessage);
    if (!confirmation) {
      return false;
    }
    const wrapper = unlockButton.parentElement.parentElement;
    wrapper.querySelectorAll('input, select, textarea')
      .forEach(element => element.removeAttribute('disabled'));
    unlockButton.parentElement.remove();
    wrapper.classList.remove('field-protected');
  }

  /**
   * @todo
   */
  Drupal.behaviors.fieldProtect = {
    processedFields: [],
    attach: function (context, settings) {
      const fieldsToProcess = Object.keys(settings.fieldProtect).filter(name => this.processedFields.indexOf(name) === -1);
      fieldsToProcess.map(fieldName => {
        const fieldSetting = settings.fieldProtect[fieldName];
        const wrapper = document.querySelector('[data-drupal-selector="' + fieldSetting.wrapperSelector + '"]');
        wrapper.querySelectorAll('input, select, textarea')
          .forEach(element => element.setAttribute('disabled', '1'));
        this.processedFields.push(fieldName);
        const button = wrapper.querySelector('.unlock-element > button');
        button.addEventListener('click', onClick);
      });
    },
  };

}(Drupal, document));
